unit Unit9;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls,  StdCtrls, ComCtrls,
  TeEngine, Series, GanttCh, TeeProcs, Chart,
  UnitV, Unit7, Unit10 ;

type
  TForm9 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label4: TLabel;
    Edit2: TEdit;
    Label5: TLabel;
    Edit3: TEdit;
    Label6: TLabel;
    Edit4: TEdit;
    Label7: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label8: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    Edit9: TEdit;
    Splitter1: TSplitter;
    Edit10: TEdit;
    Edit11: TEdit;
    Label3: TLabel;
    Edit12: TEdit;
    CheckBox1: TCheckBox;
    Edit8: TEdit;
    Label9: TLabel;
    LabelA: TLabel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Chart1: TChart;
    Series1: TGanttSeries;
    Label1: TLabel;
    EditD1: TEdit;
    Label2: TLabel;
    EditD2: TEdit;
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    LabelN: TLabel;
    Button8: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Chart1ClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private 錾 }
    n  : integer ;            // 1y[W̍őf[^
    nl : array of integer ;   // f[^ԍi[z
  public
    { Public 錾 }
  end;

var
  Form9: TForm9;

implementation

uses
   Unit1 ;

{$R *.dfm}

// J
procedure TForm9.FormShow(Sender: TObject);
begin
   Width  := Fm9_w ;
   Height := Fm9_h ;
   Panel1.Height := Fm9_p1h ;
   EditD1.Text := Fm9_d1 ;
   EditD2.Text := Fm9_d2 ;
   RadioGroup1.ItemIndex := Fm9_su ;
   //
   n  := 100 ;    // 1y[W̍őf[^
   SetLength(nl,n) ;

   LabelN.Caption := '' ;
   Edit2.Text := '' ;
   Edit3.Text := '' ;
   Edit4.Text := '' ;
   Edit5.Text := '' ;
   Edit6.Text := '' ;
   Edit7.Text := '' ;
   Edit8.Text := '' ;
   Edit9.Text := '' ;
   Edit10.Text := '' ;
   Edit11.Text := '' ;
   Edit12.Text := '' ;
   CheckBox1.Checked := False ;
   LabelA.Caption := '쐬ҁF';

   Button1.SetFocus ;
end;

// 
procedure TForm9.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   nl := nil ;
   Series1.Clear ;
   Fm9_w    := Width ;
   Fm9_h    := Height ;
   Fm9_p1h  := Panel1.Height ;
   Fm9_d1   := EditD1.Text ;
   Fm9_d2   := EditD2.Text ;
   Fm9_su   := RadioGroup1.ItemIndex ;

   Action := caFree ;
end;

// XV
procedure TForm9.Button1Click(Sender: TObject);
var
   su : integer ;
   d1,d2 : string ;
   s : array of string ;
   w : string ;
   n1,i : integer ;
   ds,ss1,ss2 : string ;
   dd1,dd2 : double ;
begin
   su := RadioGroup1.ItemIndex ;
   d1 := EditD1.Text ;
   d2 := EditD2.Text ;
   if (Trim(d1) = '') then d1 := '00000000' ;
   if (Trim(d2) = '') then d2 := '99999999' ;
   d1 := '''' + d1 + '''' ;
   d2 := '''' + d2 + '''' ;
   SetLength(s ,TABLE4N);

   w :=      '( (PDATE1 IS NOT NULL) AND (PDATE1 >= '+d1+') AND (PDATE1 <= '+d2+') ' ;
   w := w + 'OR (PDATE2 IS NOT NULL) AND (PDATE2 >= '+d1+') AND (PDATE2 <= '+d2+') ' ;
   w := w + 'OR (DATE1 IS NOT NULL) AND (DATE1 >= '+d1+') AND (DATE1 <= '+d2+') ' ;
   w := w + 'OR (DATE2 IS NOT NULL) AND (DATE2 >= '+d1+') AND (DATE2 <= '+d2+') ' ;
   w := w + 'OR (NDATE IS NOT NULL) AND (NDATE >= '+d1+') AND (NDATE <= '+d2+') ' ;
   w := w + ')' ;
   if (su = 0) then
      w := w + 'AND (ENDF = 0)'
   else if (su = 1) then
      w := w + 'AND (ENDF = 1)' ;
   n1:= Form1.TableRef('*',TABLE4,w,'N');
   if (n1 > n) then n1 := n ;

   with Series1 do begin
      Clear ;
      for i:=1 to n1 do begin
         if (i = 1) then
            Form1.TableFirst(s)
         else
            Form1.TableNext(s);

         nl[i-1] := SInt(s[0]) ; // N
         ds  := s[3] ;  // vWFNg
         ss1 := s[10] ; // PDATE1
         ss2 := s[11] ; // PDATE2
         if (ss1 <> '') and (ss2 <> '') then begin
            dd1 := EncodeDate(SInt(Copy(ss1,1,4)),SInt(Copy(ss1,5,2)),SInt(Copy(ss1,7,2))) ;
            dd2 := EncodeDate(SInt(Copy(ss2,1,4)),SInt(Copy(ss2,5,2)),SInt(Copy(ss2,7,2))) ;
            AddGanttColor(dd1, dd2, i, ds, clAqua);
         end;
         ss1 := s[12] ; // DATE1
         ss2 := s[13] ; // DATE2
         if (ss1 <> '') and (ss2 <> '') then begin
            dd1 := EncodeDate(SInt(Copy(ss1,1,4)),SInt(Copy(ss1,5,2)),SInt(Copy(ss1,7,2))) ;
            dd2 := EncodeDate(SInt(Copy(ss2,1,4)),SInt(Copy(ss2,5,2)),SInt(Copy(ss2,7,2))) ;
            AddGanttColor(dd1, dd2, i, ds, clBlue);
         end;
         ss1 := s[14] ; // NDATE
         if (ss1 <> '') then begin
            dd1 := EncodeDate(SInt(Copy(ss1,1,4)),SInt(Copy(ss1,5,2)),SInt(Copy(ss1,7,2))) ;
            dd2 := EncodeDate(SInt(Copy(ss1,1,4)),SInt(Copy(ss1,5,2)),SInt(Copy(ss1,7,2))) + 1 ;
            AddGanttColor(dd1, dd2, i, ds, clGreen);
         end;
      end;
      GetHorizAxis.ExactDateTime:=True;
	   GetHorizAxis.Increment:=DateTimeStep[dtOneDay];
   end;

   Form1.TableClose ;

   s := nil ;
end;

// 
procedure TForm9.Button2Click(Sender: TObject);
begin
   Chart1.LeftAxis.Scroll(-10,False) ;
end;

// 
procedure TForm9.Button3Click(Sender: TObject);
begin
   Chart1.LeftAxis.Scroll(10,False) ;
end;

// `[gNbN
procedure TForm9.Chart1ClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   m,r : integer ;
   s : array of string ;
   w : string ;
begin
   LabelN.Caption := '' ;
   Edit2.Text := '' ;
   Edit3.Text := '' ;
   Edit4.Text := '' ;
   Edit5.Text := '' ;
   Edit6.Text := '' ;
   Edit7.Text := '' ;
   Edit8.Text := '' ;
   Edit9.Text := '' ;
   Edit10.Text := '' ;
   Edit11.Text := '' ;
   Edit12.Text := '' ;
   CheckBox1.Checked := False ;
   LabelA.Caption := '쐬ҁF';

   m := Round(Series.YValue[ValueIndex]) ;
   if (m < 1)or(m > n) then exit;
   r := nl[m-1] ;

   SetLength(s ,TABLE4N);

   w := 'N=' + IntToStr(r) ;
   Form1.TableRef('*',TABLE4,w,'');
   Form1.TableFirst(s);
   Form1.TableClose ;

   LabelN.Caption := s[0];
   Edit2.Text  := s[3];
   Edit4.Text  := s[4];
   Edit5.Text  := s[5];
   Edit6.Text  := s[6];
   Edit7.Text  := s[7];
   Edit8.Text  := s[8];
   Edit9.Text  := s[9];
   Edit10.Text := s[10]+'`'+s[11];
   Edit11.Text := s[12]+'`'+s[13];
   Edit12.Text := s[14];
   CheckBox1.Checked := False ;
   if (SInt(s[15]) <> 0) then
      CheckBox1.Checked := True ;

   m := SInt(s[1]) ;
   r := SInt(s[2]) ;
   if (s[0] = '') then begin
      m := 0;
      r := 0;
   end;

   s := nil ;

   // 
   if (r > 0) then begin
      SetLength(s ,TABLE3N);
      w := 'N=' + IntToStr(r) ;
      Form1.TableRef('*',TABLE3,w,'');
      Form1.TableFirst(s);
      Form1.TableClose ;
      Edit3.Text := s[1] + '@' + s[2] ;
      s := nil ;
   end;

   // 쐬
   if (r > 0) then begin
      SetLength(s ,TABLE2N);
      w := 'N=' + IntToStr(m) ;
      Form1.TableRef('*',TABLE2,w,'');
      Form1.TableFirst(s);
      Form1.TableClose ;
      LabelA.Caption := '쐬ҁF'+s[2] ;
      s := nil ;
   end;
end;

// 
procedure TForm9.Button5Click(Sender: TObject);
begin
   Panel1.Height := 172 ;
end;

// 
procedure TForm9.Button6Click(Sender: TObject);
begin
   Panel1.Height := 25 ;
end;

// ҏW
procedure TForm9.Button7Click(Sender: TObject);
var
   n : integer ;
   fm : TForm7 ;
begin
   n := SInt(LabelN.Caption) ;
   if (n <= 0) then exit ;

   S_TYPE := 1 ;
   S_CODE1:= n ;
   try
      fm := TForm7.Create(Application) ;
      fm.Caption := 'vWFNgҏW';
      fm.Show ;
   except
      ;
   end;
end;

// ڍ
procedure TForm9.Button8Click(Sender: TObject);
var
   n : integer ;
   fm : TForm10 ;
begin
   if (Edit2.Text = '') then exit ;
   n := SInt(LabelN.Caption) ;
   if (n <= 0) then exit ;

   S_CODE1 := n ;
   try
      fm := TForm10.Create(Application) ;
      fm.Show ;
   except
      ;
   end;
end;

end.
