unit UnitV;

interface

uses
   Windows,SysUtils ;

const
   TABLE1  = 'SECTION' ;   // e[u
   TABLE1N = 2 ;           // tB[h
   TABLE2  = 'MEMBER' ;    // o[e[u
   TABLE2N = 3 ;           // tB[h
   TABLE3  = 'COMPANY' ;   // e[u
   TABLE3N = 3 ;           // tB[h
   TABLE4  = 'ZPROJECT' ;  // vWFNge[u
   TABLE4N = 16 ;          // tB[h
   TABLE5  = 'ZPRJ_' ;     // evWFNgڍ׃f[^̖̃c[e[u
   TABLE5N = 4 ;           // tB[h
   TABLE6  = 'ZMN_' ;      // evWFNgڍ׃f[^̐}ʏe[u
   TABLE6N = 20 ;          // tB[h
   TABLE7  = 'REV_' ;      // evWFNgڍ׃f[^̉ee[u
   TABLE7N = 5 ;           // tB[h

var
   AppPath  : string ;  // vÔtH_@Ō͕Ku\v
   DBserv   : string ;  // T[o[iIPAhX{':'iu192.168.0.0:vj́ulocalhost:vj
   DBfold   : string ;  // T[o[̃f[^̃tH_@Ō͕Ku\vŏIĉBFuC:\data\v
   DBname   : string ;  // f[^x[Xigq́u.FDBvjtH_͕sv@FuJWWDB.FDBv
   PCno     : integer ; // PCpҖ̔ԍ
   PCname   : string ;  // PCpҖ
   S_TYPE   : integer ; // P_TYPEւ̎󂯓np
   S_CODE1  : integer ; // P_CODE1ւ̎󂯓np
   Fm8_w    : integer ; // Form8̕
   Fm8_h    : integer ; // Form8̍
   Fm8_c    : array[0..5] of integer ; // Form8SG1Z
   Fm8_p1h  : integer ; // Form8Panel1̍
   Fm9_w    : integer ; // Form9̕
   Fm9_h    : integer ; // Form9̍
   Fm9_p1h  : integer ; // Form9Panel1̍
   Fm9_d1   : string ;  // Form9 \Jnt yyyymmdd`
   Fm9_d2   : string ;  // Form9 \It yyyymmdd`
   Fm9_su   : integer ; // Form9 ώw
   Fm10_w   : integer ; // Form10̕
   Fm10_h   : integer ; // Form10̍
   Fm10_t1w : integer ; // Form10TreeView1̕
   Fm10_f   : string ;  // Form10/t@C}̑OwtH_

   function ESCcheck : Boolean ;

   function SInt(s:string):integer ;
   function SFlo(s:string):single ;
   function SDbl(s:string):double ;
   function CheckNum(s:string):Boolean ;
   function MidStr2(S:string; V1,V2:integer;var V3:integer) : string ;
   function QTrim(s:string):string ;
   function HanToZen(s:string):string ;
   function ZenToHan(s:string):string ;
   function GetStrCode(S:string) : String ;
   function GetStrName(S:string) : String ;
   function CheckDate(s:string) : Boolean ;
   function GetNetDrive(drv:string):string;

   function JWCcheck(FName:string;var Fmemo:string) : Boolean ;
   function JWKcheck(FName:string;var Fmemo:string) : Boolean ;
   function JWWcheck(FName:string;var Fmemo:string) : Boolean ;
   function JWW_GetCStr(var F:File):String;
   function GetJWmemo(f:String):String ;

implementation

function ESCcheck : Boolean ;
begin
   Result := False ;
   if ((GetAsyncKeyState(VK_ESCAPE)and $8000)>0) then
      Result := True ;
end;

// ---------- - ---------- - ----------
//       ֐E葱
//       Ƃ̕ϊ֐E葱
// ---------- - ---------- - ----------
// 񁨐
function SInt(s:string):integer ;
var
   a,i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then
         a := 0;
   end
   else
      a := 0;
   Result := a;
end;

// 񁨎(float(single))
function SFlo(s:string):single ;
var
   a : single ;
   i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then a := 0.0;
   end
   else
      a := 0.0;
   Result := a;
end;

// 񁨎(double)
function SDbl(s:string):double ;
var
   a : double ;
   i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then
         a := 0.0;
   end
   else
      a := 0.0;
   Result := a;
end;

// 񂪐ō\Ă邩`FbN
//    ̏ꍇ True ɂȂ
function CheckNum(s:string):Boolean ;
var
   i : integer ;
   ss: string ;
begin
   Result := True ;
   for i:=1 to Length(s) do begin
      ss := Copy(s,i,1);
      if (ss < '0')or(ss > '9') then begin
         Result := False ;
         break ;
      end;
   end;
end;

{ ̎wʒu炎oCgo܂
   in:S  ... ̕
     :V1 ... oJnʒu(1`)
     :V2 ... ooCg
 	out:V3 .. ۂɔooCg
   out: .... o
ŌA̕Ȃ悤ɒ }
function MidStr2(S:string; V1,V2:integer;var V3:integer) : string ;
var s1,s_1 : string ;
   i,l : integer ;
   f:Boolean;
begin
   l := Length(S) ;
   if (S = '')or(V1 < 1)or(V1 > l)or(V2 <= 0) then begin
       Result := '' ;
       V3 := 0;
       exit;
   end;
	s1:='';
   V3:=0;
	i:=1;
	f:=True;
	while(f)do begin
      s_1 := Copy(S,i,2) ;
		if (Ord(s_1[1]) >= 128)and(Ord(s_1[1]) <= 159)
       or(Ord(s_1[1]) >= 224)and(Ord(s_1[1]) <= 253) then begin
			if (i >= V1)and(i+1 <= V1+V2-1) then begin
         	// s1:=s1+S[i]+S[i+1];
            s1 := s1 + s_1 ;
         	V3:=V3+2;
         end;
			i:=i+2;
      end
      else begin
			if (i >= V1)and(i <= V1+V2-1) then begin
         	// s1:=s1+S[i];
            s1 := s1 + s_1[1] ;
         	Inc(V3);
         end;
			Inc(i);
      end;
		if (i > l) then f:=False;
   end;
   Result := s1 ;
end;

// w蕶
//    PpEdpERg[R[h֐
function QTrim(S:String): String ;
var
   i,i1:Integer ;
	ss,r,t : string ;
begin
	r := '' ;
	i := 1 ;
	i1 := Length(S) ;
	while(i <= i1) do begin
      ss := Copy(S,i,2) ;
		if (Ord(ss[1]) >= 128)and(Ord(ss[1]) <= 159)
       or(Ord(ss[1]) >= 224)and(Ord(ss[1]) <= 253) then begin
			if ((i+1)<= i1) then begin
	      	// 
				t := ss ;
				r := r + t ;
				i := i + 2 ;
         end
         else
         	Inc(i);
		end
      else begin
      	// ANK
			t := ss[1] ;
			if (t <> '''')and(t <> '"')and(Ord(ss[1]) >= 32) then r := r + t ;
	      Inc(i);
      end;
   end;
	Result := r ;
end;

// pSp
//    p̍ő啶512܂
function HanToZen(s:string) : string ;
var
   Buf: array[0..1024] of Char;
   r  : string;
begin
   LCMapString(GetUserDefaultLCID,LCMAP_FULLWIDTH or LCMAP_KATAKANA,
      PChar(s), Length(s)+1, Buf, 1024);   // pSp,Ђ灨Ji
   r := string(Buf);
   Result := r;
end;

// Spp
//    Sp̍ő啶͈ꉞ512܂
function ZenToHan(s:string) : string ;
var
   Buf: array[0..1024] of Char;
   r  : string;
begin
   LCMapString(GetUserDefaultLCID,LCMAP_KATAKANA or LCMAP_HALFWIDTH,
      PChar(s), Length(s)+1, Buf, 1024);
   r := string(Buf);
   Result := r;
end;

// u:v`́̕A擾
function GetStrCode(S:string) : String ;
var
   i : Integer ;
begin
   Result := '' ;
   i := AnsiPos(':',S);
   if (i = 0)or(Length(S) = 0) then exit ;

   Result := Copy(S,1,i-1);
end;

// u:v`́̕A擾
function GetStrName(S:string) : String ;
var
   i : Integer ;
begin
   Result := '' ;
   i := AnsiPos(':',S);
   if (i = 0)or(Length(S) = 0) then exit ;

   Result := Copy(S,i+1,Length(S));
end;

// t̃`FbN
//    s : t@yyyymmdd`
// ret
//    True : OK  False : Error
function CheckDate(s:string) : Boolean ;
var
   dd: double ;
begin
   Result := False ;
   if (Length(s) <> 8) then exit ;
   if not(CheckNum(s)) then exit ;
   try
      dd := EncodeDate(SInt(Copy(s,1,4)),SInt(Copy(s,5,2)),SInt(Copy(s,7,2)));
   except
      exit ;
   end;
   if (dd < 0.0) then exit ;
   Result := True ;
end;

// hCů蓖ĂĂ鋤LfBNg擾
//		drv : zhCuiD:AH:AEEEj
//		ret : LfBNg
//				Ⴄꍇ́AhCû܂ܕԂ
function GetNetDrive(drv:string):string;
var
	ShareName: array[0..255] of Char ;
   Size: DWORD;
   s : string ;
begin
	Size := 256;
   if (WNetGetConnection(PChar(drv), ShareName, Size) = NO_ERROR) then
		s := string(ShareName)
   else
		s := drv ;
   Result := s ;
end;

// ---------- - ---------- - ----------
//       iv֘A֐E葱
//       t@C`FbNE擾
// ---------- - ---------- - ----------

// JWCt@C̃`FbN
//    FName : FileName(FullPath)
//    Fmemo : 
// ret: True : OK  False : Error
function JWCcheck(FName:string;var Fmemo:string) : Boolean ;
var
   F : File ;
   i : integer ;
   Buff : array [0..40] of Char ;
begin
   Result := False ;
   Fmemo  := '' ;
	try
   	AssignFile(F, FName);
		FileMode := 0;    // t@C[hǎpɐݒ
      Reset(F, 1);

      for i:=0 to 40 do
         Buff[i] := #0 ;

	   BlockRead(F, Buff, 20);
      if (Buff = 'jw_cad(c)data.......') then begin
   	   BlockRead(F, Buff, 20);    // ǂݔ΂
   	   BlockRead(F, Buff, 32);    // Rg(i)
         Fmemo := QTrim(Buff) ;
   	   BlockRead(F, Buff, 32);    // Rg(i)
         Fmemo := Fmemo + ' ' + QTrim(Buff) ;
         Result := True ;
      end;
	except
      ;
	end;
	CloseFile(F);
end;

// JWKt@C̃`FbN
//    FName : FileName(FullPath)
//    Fmemo : 
// ret: True : OK  False : Error
function JWKcheck(FName:string;var Fmemo:string) : Boolean ;
var
   F : File ;
   i : integer ;
   Buff : array [0..40] of Char ;
begin
   Result := False ;
   Fmemo  := '' ;
	try
   	AssignFile(F, FName);
		FileMode := 0;    // t@C[hǎpɐݒ
      Reset(F, 1);

      for i:=0 to 40 do
         Buff[i] := #0 ;

	   BlockRead(F, Buff, 20);
      if (Buff = 'jw_cad(c)sym........') then begin
   	   BlockRead(F, Buff, 20);    // ǂݔ΂
   	   BlockRead(F, Buff, 32);    // Rg(i)
         Fmemo := QTrim(Buff) ;
   	   BlockRead(F, Buff, 32);    // Rg(i)
         Fmemo := Fmemo + ' ' + QTrim(Buff) ;
         Result := True ;
      end;
	except
      ;
	end;
	CloseFile(F);
end;

// JWWt@C̃`FbN
//    FName : FileName(FullPath)
//    Fmemo : 
// ret: True : OK  False : Error
function JWWcheck(FName:string;var Fmemo:string) : Boolean ;
var
   F : File ;
   i : integer ;
   Buff : array [0..8] of Char ;
begin
   Result := False ;
   Fmemo  := '' ;
	try
   	AssignFile(F, FName);
		FileMode := 0;    // t@C[hǎpɐݒ
      Reset(F, 1);

      for i:=0 to 8 do
         Buff[i] := #0 ;

	   BlockRead(F, Buff, 8);
      if (Buff = 'JwwData.') then begin
   		BlockRead(F,Buff,4);       // ǂݔ΂(Version)
         Fmemo := JWW_GetCStr(F);   // Rg
         Fmemo := MidStr2(QTrim(Fmemo),1,80,i) ;
         Result := True ;
      end;
	except
      ;
	end;
	CloseFile(F);
end;

// JWWł̕ǂݎ
// iA65534܂łǂ߂܂̂Ō䒍Ӊj
function JWW_GetCStr(var F:File):String;
var
	i,j,k : Integer ;
	Buf1 : array [1..258] of Char ;
	s : String ;
begin
   BlockRead(F,Buf1,1);	i := Integer(Buf1[1]) ;
	if (i <> 255) then begin
		BlockRead(F,Buf1,i);
   	s := Copy(Buf1,1,i);
   end
   else begin
		s := '' ;
	   BlockRead(F,Buf1,2);
      i := Integer(Buf1[1]) ;
      j := Integer(Buf1[2]) ;
		for k:=1 to j do begin
			BlockRead(F,Buf1,256);
   		s := s + Copy(Buf1,1,256);
		end;
		BlockRead(F,Buf1,i);
   	s := s + Copy(Buf1,1,i);
	end;
   Result := s ;
end;

// JW̃ǂݍ
function GetJWmemo(f:String):String ;
var
	ex,s : String ;
begin
   Result := '';
	ex := AnsiUpperCase(ExtractFileExt(f)) ;
	if (ex = '.JWC') then begin
      if (JWCcheck(f,s)) then
         Result := s ;
   end
   else if (ex = '.JWK') then begin
      if (JWKcheck(f,s)) then
         Result := s ;
   end
   else if (ex = '.JWW')or(ex = '.JW$') then begin
      if (JWWcheck(f,s)) then
         Result := s ;
   end
   else if (ex = '.BAK')or(Copy(ex,1,3) = '.BK') then begin
      if (JWCcheck(f,s)) then
         Result := s
      else if (JWWcheck(f,s)) then
         Result := s ;
   end
   else if (ex = '.JWS') then begin
      // JWS`Ƀ͂܂
   end;
end;

end.
